#include "stat.h"
#include "curs.h"
#include <ncurses.h>
#include <signal.h>
#include <unistd.h>

void
itstime(int errnum)
{
 extern struct registers regis;
 int len;
 WINDOW *genwin, *etherwin, *plipwin, *typewin;
 

 genwin = subwin(stdscr, 5, 22, 3, 10);
   mvwprintw(genwin, 0, 0, "GENERAL");
   mvwprintw(genwin, 2, 0, "Kb/sec:        %7.2f",
	(regis.etherbytes + regis.plipbytes + regis.otherbytes) / 1024.0);
   mvwprintw(genwin, 3, 0, "Frames/sec:    %7d",
	regis.ethercount + regis.plipcount + regis.othercount);

   if((regis.ethercount + regis.plipcount + regis.othercount) == 0)
     len = 0;
   else
     len = (regis.etherbytes + regis.plipbytes + regis.otherbytes)/
           (regis.ethercount + regis.plipcount + regis.othercount);
   mvwprintw(genwin, 4, 0, "Av. frame len: %7d", len);



 etherwin = subwin(stdscr, 6, 22, 10, 10);
   mvwprintw(etherwin, 0, 0, "ETHERNET");
   mvwprintw(etherwin, 2, 0, "Kb/sec:        %7.2f",
	regis.etherbytes/1024.0);
   mvwprintw(etherwin, 3, 0, "Frames/sec:    %7d",
	regis.ethercount);
   if(regis.ethercount == 0)
     len = 0;
   else
     len = regis.etherbytes/regis.ethercount;
   mvwprintw(etherwin, 4, 0, "Av. frame len: %7d", len);
   mvwprintw(etherwin, 5, 0, "Load:          %6.2f%%",
	regis.etherbytes*100.0/1250000.0);



 plipwin = subwin(stdscr, 5, 22, 18, 10);
   mvwprintw(plipwin, 0, 0, "PLIP");
   mvwprintw(plipwin, 2, 0, "Kb/sec:        %7.2f",
	regis.plipbytes/1024.0);
   mvwprintw(plipwin, 3, 0, "Frames/sec:    %7d",
	regis.plipcount);
   if(regis.plipcount == 0)
     len = 0;
   else
     len = regis.plipbytes/regis.plipcount;
   mvwprintw(plipwin, 4, 0, "Av. frame len: %7d", len);
 


 typewin = subwin(stdscr, 20, 30, 3, 50);
   mvwprintw(typewin, 0, 0, "TYPES PER SECOND");
   mvwprintw(typewin, 2, 0, "IP:       %7d", regis.ip);
   mvwprintw(typewin, 3, 0, "ARP:      %7d", regis.arp);
   mvwprintw(typewin, 4, 0, "RARP:     %7d", regis.rarp);
   mvwprintw(typewin, 5, 0, "IPX:      %7d", regis.ipx);
   mvwprintw(typewin, 7, 0, "Appletalk");
   mvwprintw(typewin, 9, 0, "AARP:     %7d", regis.aarp);
   mvwprintw(typewin, 10, 0, "RTMPRD:   %7d", regis.rtmprd);
   mvwprintw(typewin, 11, 0, "RTMPREQ:  %7d", regis.rtmpreq);
   mvwprintw(typewin, 12, 0, "NBP:      %7d", regis.nbp);
   mvwprintw(typewin, 13, 0, "ATP:      %7d", regis.atp);
   mvwprintw(typewin, 14, 0, "AEP:      %7d", regis.aep);
   mvwprintw(typewin, 15, 0, "ZIP:      %7d", regis.zip);
   mvwprintw(typewin, 16, 0, "ADSP:     %7d", regis.adsp);
   mvwprintw(typewin, 19, 0, "Unknown:  %7d", regis.unknown_type);



 touchwin(stdscr);
 refresh();

 set_null();

 if (signal(SIGALRM, itstime) == SIG_ERR){
	perror("Signal error: ");
	exit(5);}
 alarm(1);
 return;
}
